load_network_genes= function(fileName,genenames,rem=0){

data= read.table(fileName,stringsAsFactors =FALSE, sep="\t",na.strings = "null",header=TRUE);
print("file loaded.");
data2=unique(data[,c(1,2)]);
if(length(genenames)==0)genenames=unique(sort(c(data[,1],data[,2])));
l=list();length(l)<- length(genenames);
#build a list of gene names and their ranks and put them in a hashtable

u=match(data2[,1],genenames);
v=match(data2[,2],genenames);

for(i in 1:dim(data2)[1]){
if(!is.na(u[i]) && !is.na(v[i]) && u[i]!=v[i]){l[[u[i]]]=c(l[[u[i]]],v[i]); l[[v[i]]]=c(l[[v[i]]],u[i]);}
}
n=0;for(i in 1:length(genenames))if(length(l[[i]])){l[[i]] <- unique(sort(l[[i]]));n=n+length(l[[i]]); }

p=0;for(i in 1:length(genenames))if(length(l[[i]])>0)p=p+1;

if (rem){
 s=unlist(lapply(l,length));
 si=which(s>rem);
 for (i in si){
  for (j in l[[i]]){
    if(length(l[[j]])>1){l[[j]]=l[[j]][-which(l[[j]]==i)];} else {l[j] <- list(NULL);p=p-1;}
  } 
  n=n-2*length(l[[i]]); l[i] <- list(NULL);p=p-1;
 }
}

print(paste("Network constructed. Contains ",n ,"interactions involving ",p," of the genes"));
return (list(network=l,genes=genenames));
}

surround2= function(x,i,net1,maxConnections2=20000,nofirstorder=FALSE){
 if (length(x)){
   if (length(x)<=maxConnections2){nett=unique(sort(unlist( net1[x] )));}else {nett=unique(sort(x));} 
   self=which(nett==i); 
   if (nofirstorder) self=unique(c(self,which(nett %in% net1)));
   if (length(self))nett=nett[-self];
   return(nett);
 } else{ return(NULL);}
}


load_network_influence= function(fileName,mappingfileName,genenames,usenet){
library(rhdf5)
#h5ls(fileName)#/hpf/largeprojects/agoldenb/aziz/hotnet2-1.0.1/influence_matrices/irefindex/iref_ppr_0.45.h5
x=h5read(fileName,"PPR");
y=read.table(mappingfileName, header=FALSE);
map=match(y[,2],genenames);
#H5close()
#l001=apply(x,1,function(r)length(which(r>0.01)));
#l00025=apply(x,1,function(r)length(which(r>0.0025)));
l=list();length(l)<- length(genenames);
for (i in 1:length(l)){
 ind=which(map==i);
 if(length(ind)==1){
   near<- which(x[ind,]>usenet);
   if (length(near)){
     indrem=which(near==ind);
     if (length(indrem)){ if (length(near[-indrem]))mappednear= map[near[-indrem]];} else {mappednear= map[near];}
     if (length(mappednear)){l[[i]]<- mappednear[which(!is.na(mappednear))];}  
   }else l[[i]]<- c();
 }
}
return(l)
}

networkAsTable=function(net,focusgenes=c()){
l=sum(unlist(lapply(net$network,length)))
interactorA=rep("",l);interactorB=rep("",l);type=rep("x",l);
h=1;
for (i in 1: length(net$network)){
 inter=net$network[[i]];ind=c();
 if(length(inter)){
   interactorA[h:(h+length(inter)-1)]=net$genes[i];
   interactorB[h:(h+length(inter)-1)]=net$genes[inter];
   if (length(focusgenes)){
    if (net$genes[i] %in% focusgenes)ind=which(net$genes[inter] %in% focusgenes);
    if (length(ind))type[(h:(h+length(inter)-1))[ind]]="y";
   }
   h=h+length(inter);
 }
}
return(data.frame(interactorA,type,interactorB))
}

